var selectModelContainer = "#general_model_container";
/**
 * JavaScript字符串添加replaceAll方法
 * reallyDo：被搜索的子字符串。
 * replaceWith：用于替换的子字符串。
 * ignoreCase: 是否忽略大小写
 */
String.prototype.replaceAll = function(reallyDo, replaceWith, ignoreCase) {
	if (!RegExp.prototype.isPrototypeOf(reallyDo)) {
		return this.replace(new RegExp(reallyDo, (ignoreCase ? "gi": "g")), replaceWith);
	} else {
		return this.replace(reallyDo, replaceWith);
	}
}
/**
 * 根据格式对日期处理(如果是当天则显示时分)
 * @param {} date	时间 格式
 * @param {} format	yyyyMMddHHmmss 年月日时分秒  MMddHHmm 月日时分 HHmm 时分  
 * @return {}
 */
function formatDate(date,format) {
	var time = new Date(date),
		today = new Date(),
		strTime = '';

	if (format == 'yyyyMMdd') {
		strTime = time.getFullYear() +addZero(time.getMonth() + 1)+ addZero(time.getDate());
	//} else if (time.getFullYear() == today.getFullYear() && time.getMonth() == today.getMonth() && time.getDate() == today.getDate()) {
	//	strTime = addZero(time.getHours()) + ':' + addZero(time.getMinutes());
	} else if (format == 'yyyyMMddHHmmss') {
		strTime = time.getFullYear() + '.' + addZero(time.getMonth() + 1) + '.' + addZero(time.getDate()) + ' ' + addZero(time.getHours()) + ':' + addZero(time.getMinutes()) + ':' + addZero(time.getSeconds());
	} else if (format == 'yyyy-MM-dd') {
		strTime = time.getFullYear() + '-' + addZero(time.getMonth() + 1) + '-' + addZero(time.getDate());
	} else if (format == 'MMddHHmm') {
		if(time.getHours()==0&&time.getMinutes()==0){
			strTime = addZero(time.getMonth() + 1) + '-' + addZero(time.getDate());
		}else{
			strTime = addZero(time.getMonth() + 1) + '-' + addZero(time.getDate()) + ' ' + addZero(time.getHours()) + ':' + addZero(time.getMinutes());
		}
	} else if (format == 'HHmm') {
		strTime = addZero(time.getHours()) + ':' + addZero(time.getMinutes());
	}else if (format == 'HHmmss') {
        strTime = addZero(time.getHours()) + ':' + addZero(time.getMinutes())+ ':' + addZero(time.getSeconds());
    }
	
	return strTime;
}

function checkIsToday(date){
	var time = new Date(date),
	today = new Date();
	var isToday = false;
	if(time.getDate() == today.getDate()){
		isToday = true;
	}
	return isToday;
}

function addZero(num) {
	return num <= 9 ? '0' + num : num;
}


//判断是否是同一天
function isSameDay(beforeTime,afterTime) {
    var beforeDate = new Date(beforeTime),
        afterDate = new Date(afterTime);
    if (beforeDate.getFullYear() == afterDate.getFullYear() && beforeDate.getMonth() == afterDate.getMonth() && beforeDate.getDate() == afterDate.getDate()) {
        return true;
    } else {
        return false;
    }
}


/*
 * 0 1 2    0
 * 3 4 5 	3
 * 6 7 8	6
 */
function formatIndex(index) {
	return parseInt(index/3,10) * 3;
}

function setWinBeforeTitle(beforeTitle){
	localStorage.beforeTitle = beforeTitle;
}

function getWinBeforeTitle() {
	if(typeof(localStorage.beforeTitle) == "undefined"){
		return "";
	}
	return localStorage.beforeTitle;
}
/**
 * 保存用户id置后台session
 * @param user_id
 */
function setUserId(user_id){
	sessionStorage.userId = user_id;
	//alert("userId:"+getUserId());
}
function getUserId(){
	if(typeof(sessionStorage.userId) == "undefined"){
		return "";
	}
	return sessionStorage.userId;
}


/**
 * 保存用户设备id到缓存
 * @param user_id
 */
function setDeviceId(deviceId){
	localStorage.deviceId = deviceId;
}
function getDeviceId(){
	if(typeof(localStorage.deviceId) == "undefined"){
		return "";
	}
	return localStorage.deviceId;
}

function recoveryHeader(){
	$(".am-header").css("display","");
	if(window.location.pathname == "/column/column.html"){
		$(".pd-t44").css("padding-top","44px");
	}else if(window.location.pathname == "/news/detail.html" || 
			window.location.pathname == "/news/detailComment.html"||
			window.location.pathname == "/subject/before.html"||
			window.location.pathname == "/subject/detail.html"
			){
		$(".content").css("padding-top","44px");
	}else if(window.location.pathname == "/news/recommend.html"){
		$("#iScrollWrapper").removeClass("iScroll-wrapper-mobile-recommend");
		$("#iScrollWrapper").addClass("iScroll-wrapper-pc-recommend");
	}else{
		$("#iScrollWrapper").removeClass("iScroll-wrapper-mobile");
		$("#iScrollWrapper").addClass("iScroll-wrapper-pc");
	}
}
//处理中文全角并加div分段输出
function changeContent(content){
	//处理内容分段
	//var partenFul=/[\u3000]/g; //全角正则
	var partenFul=/\n/g; //换行正则
	var strs= new Array(); 
	strs = content.split(partenFul);
	var lastRes="" ;
	for(var i=0;i<strs.length;i++){
		if($.trim(strs[i]).length > 0){
			if(strs[i].charAt(0)=="　"){//中文空格
				lastRes+="<p>"+(strs[i])+"</p>";
			}else{
				lastRes+="<p>&emsp;&emsp;"+(strs[i])+"</p>";
			}
			
//			if(i < strs.length-1){
//				lastRes+="<p>&emsp;</p>"
//			}
		}
	}
	return lastRes;
}
//计算字符串长度中文算2个英文算1
function stringLength(source)  {  
	  var len = 0;  
	  for (var i=0; i<source.length; i++) {  
	    if (source.charCodeAt(i)>127 || source.charCodeAt(i)==94) {  
	       len += 2;  
	     } else {  
	       len ++;  
	     }  
	   }  
	  return len;  
	}

function catString(source,divLength,lensrc,otherdiv){
	var len = 0;
	var result = source;
	var hanzi = 0;
	var zifu = 0;
	if((lensrc*6)>(divLength-otherdiv) && (lensrc*6)< divLength){
		var sourceLength = source.length;
		for (var i=0; i<sourceLength; i++) {  
			if (source.charCodeAt(i)>127 || source.charCodeAt(i)==94) {  
				len += 2;
				hanzi++;
			} else {  
				len ++;  
				zifu++;
			}
			if((hanzi*12+zifu*7)>= (divLength-otherdiv)){
				result = source.substr(0, i)+'</br>'+source.substr(i, sourceLength);
				break;
			}
			
		}
	}
	  return result;
}

//阻止事件传播
function preventEventPropagate(event){
	if(event.stopPropagation){
		event.stopPropagation();
	}else{
		event.cancelBubble = true; 
	}
}

var Common = {
		getRootPath: function(){
			//获取当前网址，如： http://localhost:8083/uimcardprj/share/meun.jsp
			var curWwwPath=window.document.location.href;
			//获取主机地址之后的目录，如： /uimcardprj/share/meun.jsp
			var pathName=window.document.location.pathname;
			//获取带"/"的项目名，如：/uimcardprj
			var projectName=pathName.substring(0,pathName.substr(1).indexOf('/')+1);
			return projectName;
		},

		//读取cookies
		getCookie: function(name) {
			var arr,reg=new RegExp("(^| )"+name+"=([^;]*)(;|$)");
			if(arr=document.cookie.match(reg))
				return unescape(arr[2]);
			else
				return null;
		},

		//写cookies
		setCookie: function(name,value,path) {
			var Days = 30;
			var exp = new Date();
			exp.setTime(exp.getTime() + Days*24*60*60*1000);
			document.cookie = name + "="+ escape (value) + ";expires=" + exp.toGMTString()+";path="+path;
		},
		//清除cookie
		delCookie:function(name,value,path) {
			var exp = new Date();
			exp.setTime(exp.getTime()-1);
			document.cookie = name + "="+ escape (value) + ";expires=" + exp.toGMTString()+";path="+path;
		},
		timestamp: function () {
			return '_v=' + new Date().getTime() + '' + Math.floor(Math.random() * 9999 + 1000);
		},
		getQueryStringByName:function(name){
			var result = location.search.match(new RegExp("[\?\&]" + name+ "=([^\&]+)","i"));
			if(result == null || result.length < 1){
				return "";
			}
			return result[1];
		},
		getNewsViewByStyle:function(newsLists,modelStyle){
			var html = "";
			if(null == newsLists || newsLists.length ==0){
				html = "<div style='text-align:center;padding: 4px 0;font-size: 12px;' id='no_more_date'>暂无数据</div>";
			}else{
				var newsShowStyle;;
				for (var i = 0; i < newsLists.length; i++) {
					var lables = "";
					var imageHtml="";
					var digest = "";
					var channel = newsLists[i].channel;
					var imageUrl = newsLists[i].imageUrl;	
					var newsSetStyle = newsLists[i].styleId;
					var media = newsLists[i].media==null||newsLists[i].media==""?"":"来源:"+newsLists[i].media.replace("来源:","").replace("来源：","");
					if(null != newsSetStyle && undefined != newsSetStyle && "" != newsSetStyle){
						newsShowStyle = newsSetStyle;
					}else{
						newsShowStyle = modelStyle;
					}
					if(null != newsLists[i].digest)	{
						digest = '<div class="am-ft-smm am-ft-gray">'+this.disposeDigest(newsLists[i].digest)+'</div>';
					}else{
						digest = "";
					}
					if(null != newsLists[i].lableNames){
						var _$lableNames = newsLists[i].lableNames;
						for (var j = 0; j < _$lableNames.length; j++) {
							if((j+1)%3==0){
								lables += '<div class="review am-ft-lightgray news-bottom-tips">'+_$lableNames[j]+'</div>';
							}else{
								lables += '<div class="review am-ft-lightgray news-bottom-tips">'+_$lableNames[j]+'</div>';

							}
						}
					}else{
						lables = "";
					}

					if(null != imageUrl&&"" != imageUrl){
						if(imageUrl.indexOf("http")<0&&imageUrl.indexOf("https")<0){
							imageUrl = imageServerUrl + imageUrl;
						}
						imageHtml = '<div class="newsImg"><img src="'+imageUrl+'"></div>'
					}else{
						imageHtml = '<div class="newsImg"><img src="'+res+'/images/noimg.png"></div>';
					}

					var top='';
					if(newsLists[i].top=="1"){
						top='<span style="color:red;">[置顶]&nbsp;&nbsp;</span>';
					}

					//判断外链url，包括只带附件不带正文的情况
					var outurl="";
					if(newsLists[i].url!=null&&newsLists[i].url!=""){
						outurl = newsLists[i].url;
					}else if(newsLists[i].content_have=="0"&&newsLists[i].attachmentUrl){//
						if(channel!="tzyjhyqh"&&channel!="tzyjhsqh"){
							if(newsLists[i].attachmentUrl.indexOf("http")>=0||newsLists[i].attachmentUrl.indexOf("https")>=0){
								outurl=newsLists[i].attachmentUrl;
							}else{
								outurl=Common.goPdfCur(imageServerUrl+newsLists[i].attachmentUrl);
							}
						}
					}
					if("1010" == newsShowStyle){// 标题
                        html+=
                            '<div class="am-message am-flexbox" onclick="Common.goToDetail('+newsLists[i].id+',\''+outurl+'\',\''+channel+'\',\''+formatDate(null,"yyyyMMdd")+'\')">'+
                            '<div class="news-title am-flexbox-item">'+
                            '<div class="am-ft-md am-ft-black">'+top+newsLists[i].title+'</div>'+
                            '</div>'+
                            '</div>'
					}else if("1000" == newsShowStyle || "1001" == newsShowStyle){// 标题/摘要,日期
						html+=
							'<div class="am-message am-flexbox" onclick="Common.goToDetail('+newsLists[i].id+',\''+outurl+'\',\''+channel+'\',\''+formatDate(newsLists[i].createTime,"yyyyMMdd")+'\')">'+
							'<div class="news-title am-flexbox-item">'+
							'<div class="am-ft-md am-ft-black">'+top+newsLists[i].title+'</div>'+
							'<div class="am-ft-smmm am-ft-gray am-flexbox pd-t">'+
							'<div class="am-flexbox-item am-ft-right am-ft-darkgray">'+formatDate(newsLists[i].createTime,"MMddHHmm")+'</div>'+
							'</div>'+
							'</div>'+
							'</div>'
					} else if("1002" == newsShowStyle){//标题，摘要，日期
						html+=
							'<div class="am-message am-flexbox" onclick="Common.goToDetail('+newsLists[i].id+',\''+outurl+'\',\''+channel+'\',\''+formatDate(newsLists[i].createTime,"yyyyMMdd")+'\')">'+
							'<div class="news-title am-flexbox-item">'+
							'<div class="am-ft-md am-ft-black am-ft-ellipsis">'+top+newsLists[i].title+'</div>'+
							digest+
							'<div class="am-ft-smmm am-ft-gray am-flexbox pd-t">'+
							'<div class="am-flexbox-item am-ft-right am-ft-black">'+formatDate(newsLists[i].createTime,"MMddHHmm")+'</div>'+
							'</div>'+
							'</div>'+
							'</div>';
						
					} else if("1003" == newsShowStyle){//标题，摘要，标签，日期
						var timeStrFormat = formatDate(newsLists[i].createTime,"MMddHHmm");
						var timeWidthEm = 3;
						if(timeStrFormat.length > 5){
							timeWidthEm=6;
						}
						html+=
							'<div class="am-message am-flexbox" onclick="Common.goToDetail('+newsLists[i].id+',\''+outurl+'\',\''+channel+'\',\''+formatDate(newsLists[i].createTime,"yyyyMMdd")+'\')">'+
							'<div class="news-title am-flexbox-item">'+
							'<div class="am-ft-md am-ft-black am-ft-ellipsis">'+top+newsLists[i].title+'</div>'+
							digest+
							'<div class="am-ft-smmm am-ft-gray am-flexbox pd-t align-end"><div class="labelsGroupClass am-flexbox flex-wrap">'+
							lables+
							'</div><div class="am-flexbox-item am-ft-right am-ft-darkgray" style="min-width: '+timeWidthEm+'em;">'+timeStrFormat+'</div>'+
							'</div>'+
							'</div>'+
							'</div>';
					} else if("1004" == newsShowStyle){//标题，摘要，媒体出处，日期
						html+=
							'<div class="am-message am-flexbox" onclick="Common.goToDetail('+newsLists[i].id+',\''+outurl+'\',\''+channel+'\',\''+formatDate(newsLists[i].createTime,"yyyyMMdd")+'\')">'+
							'<div class="news-title am-flexbox-item">'+
							'<div class="am-ft-md am-ft-black am-ft-ellipsis">'+top+newsLists[i].title+'</div>'+
							digest+
							'<div class="am-ft-smmm am-ft-gray am-flexbox pd-t">'+
							'<div class="am-flexbox-item am-ft-darkgray">'+media+'</div>'+
							'<div class="am-flexbox-item am-ft-right am-ft-darkgray">'+formatDate(newsLists[i].createTime,"MMddHHmm")+'</div>'+
							'</div>'+
							'</div>'+
							'</div>';
					} else if("1005" == newsShowStyle){//图片，标题，摘要，日期
						
						html+=
							'<div class="am-message am-flexbox" onclick="Common.goToDetail('+newsLists[i].id+',\''+outurl+'\',\''+channel+'\',\''+formatDate(newsLists[i].createTime,"yyyyMMdd")+'\')">'+
							imageHtml+
							'<div class="news-title am-flexbox-item">'+
							'<div class="am-ft-md am-ft-black am-ft-ellipsis">'+top+newsLists[i].title+'</div>'+
							digest+
							'<div class="am-ft-smmm am-ft-gray am-flexbox pd-t">'+
							'<div class="am-flexbox-item am-ft-right am-ft-darkgray">'+formatDate(newsLists[i].createTime,"MMddHHmm")+'</div>'+
							'</div>'+
							'</div>'+
							'</div>';
						
					} else if("1006" == newsShowStyle){// 图片，标题，标签，日期
						var timeStrFormat = formatDate(newsLists[i].createTime,"MMddHHmm");
						var timeWidthEm = 3;
						if(timeStrFormat.length > 5){
							timeWidthEm=6;
						}
						html+=
							'<div class="am-message am-flexbox" onclick="Common.goToDetail('+newsLists[i].id+',\''+outurl+'\',\''+channel+'\',\''+formatDate(newsLists[i].createTime,"yyyyMMdd")+'\')">'+
							imageHtml+
							'<div class="news-title am-flexbox-item">'+
							'<div class="am-ft-md am-ft-black am-ft-ellipsis">'+top+newsLists[i].title+'</div>'+
							digest+
							'<div class="am-ft-smmm am-ft-gray am-flexbox pd-t align-end"><div class="labelsGroupClass am-flexbox flex-wrap">'+
							lables+
							'</div><div class="am-flexbox-item am-ft-right am-ft-darkgray" style="min-width: '+timeWidthEm+'em;">'+timeStrFormat+'</div>'+
							'</div>'+
							'</div>'+
							'</div>';
						
					} else if("1007" == newsShowStyle){//图片，标题，摘要，标签，日期
						html+=
							'<div class="am-message am-flexbox" onclick="Common.goToDetail('+newsLists[i].id+',\''+outurl+'\',\''+channel+'\',\''+formatDate(newsLists[i].createTime,"yyyyMMdd")+'\')">'+
							imageHtml+
							'<div class="news-title am-flexbox-item">'+
							'<div class="am-ft-md am-ft-black am-ft-ellipsis ">'+top+newsLists[i].title+'</div>'+
							digest+
							'<div class="am-ft-smmm am-ft-gray am-flexbox pd-t">'+
							'<div class="am-flexbox-item am-ft-darkgray">'+media+'</div>'+
							'<div class="am-flexbox-item am-ft-right am-ft-darkgray">'+formatDate(newsLists[i].createTime,"MMddHHmm")+'</div>'+
							'</div>'+
							'</div>'+
							'</div>'
					}else{//图片，标题，摘要，标签，日期
						html+=
							'<div class="am-message am-flexbox" onclick="Common.goToDetail('+newsLists[i].id+',\''+outurl+'\',\''+channel+'\',\''+formatDate(newsLists[i].createTime,"yyyyMMdd")+'\')">'+
							imageHtml+
							'<div class="news-title am-flexbox-item">'+
							'<div class="am-ft-md am-ft-black am-ft-ellipsis ">'+top+newsLists[i].title+'</div>'+
							digest+
							'<div class="am-ft-smmm am-ft-gray am-flexbox pd-t">'+
							'<div class="am-flexbox-item am-ft-darkgray">'+media+'</div>'+
							'<div class="am-flexbox-item am-ft-right am-ft-darkgray">'+formatDate(newsLists[i].createTime,"MMddHHmm")+'</div>'+
							'</div>'+
							'</div>'+
							'</div>'
					}

				}
			}
			
			 return html;
		},
		goToDetail:function(newsId,urls,channel,time,path){
            var user_impType =  Common.getQueryStringByName("user_impType");
			var localchannel = Common.getQueryStringByName("chnl");
			var model ="model";
			if(path!=undefined&&path!=""){
				model =path
			}
			var sourceFrom = localStorage.getItem("sourceFrom");
			if(null != sourceFrom && undefined !=sourceFrom){
				if(1==sourceFrom || 2 == sourceFrom){//1综合资讯 2 个股资讯和首页资讯
					if('null' != urls && '' != urls){
						//记录访问PV
						$.ajax({
							type: "post",
							url: window.service_prefix + "/model/pageView",
							data: {newsid:newsId,cnl: channel,localchannel: localchannel}
						});

						yaqhShowTitle(urls, '资讯详情');
					}else{
						var url = "news_content_app.html?newsid="+newsId+"&time="+time+"&user_impType="+user_impType+"&cnl="+channel+"&localchannel="+localchannel;
						yaqhShowTitle(url, '资讯详情');
					}

				}
			}else{
				if('null' != urls && '' != urls){
					//记录访问PV
					$.ajax({
						type: "post",
						url: window.service_prefix + "/model/pageView",
						data: {newsid:newsId,cnl: channel}
					});

					window.location.href=urls;
				}else{
					window.location.href="../"+model+"/news_content.html?newsid="+newsId+"&time="+time+"&user_impType="+user_impType+"&cnl="+channel;
				}
			}


		},
		goBack:function(){
			var backUrl = localStorage.getItem("backUrl");
			if(null == backUrl || undefined == backUrl || backUrl == ""){
				backUrl = "../model/general_model.html?"+"user_impType="+user_impType;
			}
			window.location.href = backUrl+"&user_impType="+user_impType;;
		},
		setBackUrl:function(backUrl){
			if(null != backUrl || undefined != backUrl || backUrl != ""){
				localStorage.setItem("backUrl",backUrl);
			}
		},
		disposeDigest:function(digest){
			if(digest.length > 30){
				digest = digest.substr(0,30)+"...";
			}
			return digest;
		},
		/**
		 * 获取静默注册url
		 * @returns {String}
		 */
		getRegistUrl : function (){
			return "https://tuc.hsmdb.com/uc/mRegister";
		},
		sendSilentReg:function(){
			var chnl_str =  this.getQueryStringByName("cnl");
			var prod_str = this.getQueryStringByName("prod");
			var openid_str = this.getQueryStringByName("openid");
			if(null == openid_str || undefined == openid_str || openid_str == ""){
				var fp = new Fingerprint();
				openid_str = fp.get();
			}
			var params = "?tuc_regt=silent_reg&prod=tzyjhtml5&channel="+chnl_str+"&uid="+openid_str+"&uidtype=openuuid";
			var regurl = this.getRegistUrl()+params;
			$.ajax({
				type: "post",
				url: regurl,
				success: function (data) {
					if("0" == data.error_no){
						//静默注册成功
						//console.log("静默注册成功");
					}else {
						//静默注册失败
						//console.log("静默注册失败");
					}
				}
			});
				
			
		},
    	html_encode:function(str){
        var s = "";
        if (str.length == 0) return "";
        s = str.replace(/&/g, "&amp;");
        s = s.replace(/</g, "&lt;");
        s = s.replace(/>/g, "&gt;");
        /*s = s.replace(/ /g, "&nbsp;");*/
        s = s.replace(/\'/g, "&#39;");
        s = s.replace(/\"/g, "&quot;");
        return s;
    	},
    	html_decode:function(str){
        var s = "";
        if (str.length == 0) return "";
        s = str.replace(/&amp;/g, "&");
        s = s.replace(/&lt;/g, "<");
        s = s.replace(/&gt;/g, ">");
        /*s = s.replace(/&nbsp;/g, " ");*/
        s = s.replace(/&#39;/g, "\'");
        s = s.replace(/&quot;/g, "\"");
        return s;
    	},
		goPdfCur:function(prdurl){
			var base = new Base64();
			var url1= prdurl.substr(0,prdurl.lastIndexOf("/")+1);
			var url2= prdurl.substr(prdurl.lastIndexOf("/")+1);
			url2=url2.replace(".pdf","");
			if(isNaN(url2.substr(url2.indexOf("_")+1))){
				prdurl = url1+base.encode(url2).replace(new RegExp("/","gm"),"_")+".pdf";
			}
			return prdurl
		}
}
$(function () {
	Common.sendSilentReg();
});
