


/**
 * 根据格式对日期处理(如果是当天则显示时分)
 * @param {} date	时间 格式
 * @param {} format	yyyyMMddHHmmss 年月日时分秒  MMddHHmm 月日时分 HHmm 时分
 * @return {}
 */
function formatDate(date,format) {
    var time = new Date(date),
        today = new Date(),
        strTime = '';

    if (time.getFullYear() == today.getFullYear() && time.getMonth() == today.getMonth() && time.getDate() == today.getDate()) {
        strTime = addZero(time.getHours()) + ':' + addZero(time.getMinutes());
    } else if (format == 'yyyyMMddHHmmss') {
        strTime = time.getFullYear() + '.' + addZero(time.getMonth() + 1) + '.' + addZero(time.getDate()) + ' ' + addZero(time.getHours()) + ':' + addZero(time.getMinutes()) + ':' + addZero(time.getSeconds());
    } else if (format == 'yyyyMMddHHmm') {
        strTime = time.getFullYear() + '-' + addZero(time.getMonth() + 1) + '-' + addZero(time.getDate()) + ' ' + addZero(time.getHours()) + ':' + addZero(time.getMinutes());
    } else if (format == 'yyyyMMdd') {
        strTime = time.getFullYear() + '-' + addZero(time.getMonth() + 1) + '-' + addZero(time.getDate());
    } else if (format == 'MMddHHmm') {
        strTime = addZero(time.getMonth() + 1) + '-' + addZero(time.getDate()) + ' ' + addZero(time.getHours()) + ':' + addZero(time.getMinutes());
    } else if (format == 'HHmm') {
        strTime = addZero(time.getHours()) + ':' + addZero(time.getMinutes());
    }else if (format == 'HHmmss') {
        strTime = addZero(time.getHours()) + ':' + addZero(time.getMinutes())+ ':' + addZero(time.getSeconds());
    }

    return strTime;
}
function addZero(num) {
    return num <= 9 ? '0' + num : num;
}


/**
 * 描述：期货资讯配置
 * @type {{}}
 */
var CommFutures = {

    /**原油期货F10合约**/
    future_crude_url:'https://open.hscloud.cn/info/v3/fut_contract',
    /***期货F10的请求地址**/
    f10_url:'https://open.hscloud.cn/info/v3/fut_contract',
    /***商品期权F10的请求地址**/
    future_f10_url:'https://open.hscloud.cn/info/v3/f10_fut_option',
    /********本地令牌服务器地址*************/
    token_url:window.service_prefix + '/token/getAccessToken',

    /********期货交易市场代码和名称**********/
    exchange_codeForName : {
            "10":"上海期货交易所",       
            "13":"大连商品交易所",     
            "15":"郑州商品交易所",    
            "20":"中国金融期货交易所",
            "31":"台湾期货交易所",       
            "32":"香港期货交易所",     
            "33":"新加坡交易所",      
            "34":"大阪证券交易所",
            "35":"韩国证券期货交易所",   
            "36":"伦敦国际金融期货和期权交易所",
            "37":"伦敦金属交易所",   
            "38":"纽约商业交易所",       
            "39":"芝加哥期货交易所",   
            "40":"芝加哥商业交易所",  
            "41":"纽约期货交易所",     
            "43":"纽约商品交易所",      
            "44":"伦敦洲际交易所",   
            "51":"芝加哥国际货币市场"
    },

    /********商品期权市场代码和名称**********/
    futureExchange_codeForName : {
        "1":"上海证券交易所",
        "2":"大连商品交易所",
        "3":"郑州商品交易所"
    },
    /*****交易方式名称********/
    delivery_methodName: {
        "1":"实物交割",
        "2":"现金结算"
    },

    fut_contract_typeName: {
        "1":"商品期货",
        "2":"货币期货",
        "3":"利率期货",
        "4":"股指期货"
    },

    /*****商品期权f10合约类型********/
    contract_typeName: {
        "1":"看涨",
        "2":"看跌"
    },

    /*****行权方式********/
    warrantway_typeName: {
        "A":"美式行权",
        "B":"混合行权",
        "E":"欧式行权",
    },


    /**
     * desp：根据参数名称得到值
     * @param name
     * @returns {*}
     */
    getQueryStringByName:function(name){
        var result = location.search.match(new RegExp("[\?\&]" + name+ "=([^\&]+)","i"));
        if(result == null || result.length < 1){
            return "";
        }
        return result[1];
    },


    getNewsViewByStyle:function(newsLists,modelStyle){
        var htmlRst = "";
        if(null == newsLists || newsLists.length ==0){
            htmlRst = "<div style='text-align:center;margin: 0;font-size:12px;' id='noDataResult_'>暂无数据</div>";
        }else{
            var newsShowStyle = modelStyle;
            htmlRst='<ul class="am-itme2">';
            for (var i = 0; i < newsLists.length; i++) {
                var lables = "";
                var imageHtml="";
                var digest = "";
                var channel = newsLists[i].channel;
                var imageUrl = newsLists[i].imageUrl;
                var newsSetStyle = newsLists[i].styleId;
                if(null != newsSetStyle && undefined != newsSetStyle && "" != newsSetStyle){
                    newsShowStyle = newsSetStyle;
                }else{
                    newsShowStyle = modelStyle;
                }
                if(null != newsLists[i].digest)	{
                    digest = '<div class="am-ft-smm am-ft-gray">'+this.disposeDigest(newsLists[i].digest)+'</div>';
                }else{
                    digest = "";
                }
                if(null != newsLists[i].lables){
                    var lableNames = newsLists[i].lables;
                    for (var j = 0; j < lableNames.length; j++) {
                        lables += '<div class="review am-ft-lightgray news-bottom-tips">'+lableNames[j].codeName+'</div>';
                    }
                }else{
                    lables = "";
                }
                if(null != imageUrl){
                    if(imageUrl.indexOf("http")<0&&imageUrl.indexOf("https")<0){
                        imageUrl = imageServerUrl + imageUrl;
                    }
                    imageHtml = '<div class="newsImg"><img src="'+imageUrl+'"></div>'
                }else{
                    imageHtml = "";
                }
                var content="";
                var subLen=60;
                if(newsLists[i].content && newsLists[i].content.length > subLen){
                    content = newsLists[i].content.substring(0,subLen)+"... "+"【<a href='javascript:void(0)' onclick='CommFutures.goToDetail("+newsLists[i].id+",\""+channel+"\")' style='color: #4b87cc;text-decoration: none;'>查看详情</a>】";
                }
                htmlRst+= ' <li>' +
                       '<p class="am-ft-blue" onclick="CommFutures.goToDetail('+newsLists[i].id+',\''+channel+'\')">'+newsLists[i].title+'</p>'+
                       '<p class="am-ft-gray border-bottom">'+newsLists[i].media+'&nbsp;&nbsp;&nbsp;&nbsp;'+formatDate(newsLists[i].updateTime,"yyyyMMddHHmm")+'</p>'+
                       '<p >'+content+'</p>'+
                       '</li>';
            }
            htmlRst = htmlRst + "</ul>";
        }

        return htmlRst;
    },
    goToDetail:function(newsId,channel){
        var sourceFrom = localStorage.getItem("sourceFrom_con");
        var userImpType =  CommFutures.getQueryStringByName("user_impType");
        if(null != sourceFrom && undefined !=sourceFrom){
            if(1==sourceFrom || 2 == sourceFrom){//1综合资讯 2 个股资讯和首页资讯
                //window.location.href="../model/news_content.html?newsid="+newsId+"&user_impType="+userImpType;
                var url =location.origin+ projectRoot+"/model/news_content_app.html?newsid="+newsId+"&user_impType="+userImpType+"&cnl="+channel;
                yaqhShowTitle(url);
            }else{
                window.location.href="../model/news_content.html?newsid="+newsId+"&user_impType="+userImpType+"&cnl="+channel;
            }
        }else{
            window.location.href="../model/news_content.html?newsid="+newsId+"&user_impType="+userImpType+"&cnl="+channel;
        }
    },
    goBack:function(){
        var backUrl = localStorage.getItem("backUrl_con");
        var userImpType =  CommFutures.getQueryStringByName("user_impType");
        if(null == backUrl || undefined == backUrl || backUrl == ""){
            backUrl = "../futures/contractInfo.html?user_impType="+userImpType;
        }
        window.location.href = backUrl+"&user_impType="+userImpType;;
    },
    setBackUrl:function(backUrl){
        if(null != backUrl || undefined != backUrl || backUrl != ""){
            localStorage.setItem("backUrl_con",backUrl);
        }
    },
    disposeDigest:function(digest){
        if(digest.length > 30){
            digest = digest.substr(0,30)+"...";
        }
        return digest;
    },
    /**
     * 获取静默注册url
     * @returns {String}
     */
    getRegistUrl : function (){
        return "https://tuc.hsmdb.com/uc/mRegister";
    },
    getxwtjUrl:function(){
    	return "https://noc.hsmdb.com/tucbe/chnl/addchnldata";
    },
    sendSilentReg:function(){
        var chnl_str =  this.getQueryStringByName("chnl");
        var prod_str = this.getQueryStringByName("prod");
        prod_str = prod_str==""?"tzyjhtml5":prod_str;
        var openid_str = this.getQueryStringByName("openid");
        if(null == openid_str || undefined == openid_str || openid_str == ""){
            var fp = new Fingerprint();
            openid_str = fp.get();
        }
        var params = "?tuc_regt=silent_reg&prod="+prod_str+"&channel="+chnl_str+"&uid="+openid_str+"&uidtype=openuuid";
        var regurl = this.getRegistUrl()+params;
        $.ajax({
            type: "post",
            url: regurl,
            success: function (data) {
                if("0" == data.error_no){
                    //静默注册成功
                    //console.log("静默注册成功");
                }else {
                    //静默注册失败
                    //console.log("静默注册失败");
                }
            }
        });
        
        var xwtjParam = "?device="+openid_str+"&version=1.0.0&channel="+chnl_str;
        var xwtjUrl = this.getxwtjUrl()+xwtjParam;
        $.ajax({
            type: "post",
            url: xwtjUrl,
            success: function (data) {
                if("0" == data.error_no){
                    //行为统计成功
                    //console.log("静默注册成功");
                }else {
                    //行为统计失败
                    //console.log("静默注册失败");
                }
            }
        });

    }
}

function yaqhShowTitle(url){
    var userImpType =  CommFutures.getQueryStringByName("user_impType");
    if(userImpType=="android"){
        window.WebViewJavascriptBridge.viewvisible(url);
    }else if(userImpType=="ios"){
        qreadyCallbacks.viewvisible(url);
    }else{
        window.location.href= url;
    }
}

