/**
 * H5调用原生的方法
 *
 * @param paramMap
 *            json格式参数
 * @returns returnVal 有值则返回
 */
function sendMessageToNative(paramMap) {
    var sysType = getSystemType();// 获取手机系统类型
    var returnVal;
    if (sysType.android) {// Android
        try {
            returnVal = window.external.jstonative(JSON.stringify(paramMap));
        } catch (e) {
            console.log("H5调用原生android callMessage方法出错：" + e.message);
        }
    } else if (sysType.ios) {// ios
        try {
            returnVal = jstonative(JSON.stringify(paramMap));

        } catch (e) {
            console.log("H5调用原生ios callMessage方法出错：" + e.message);
        }
    }
    return returnVal;
}

/**
 * 原生调用H5的业务消息
 *
 * @param paramMap
 *            JSON格式参数
 * @returns 原生调用H5 有返回则返回无则无
 */
function nativeCallBack(paramMap) {
    //TODO:根据paramMap传过来的编号，方法名进行相关业务操作
    var backMessage;
    return backMessage;
}

//获取系统类型
function getSystemType() {
    var u = navigator.userAgent;
    var userImpType = getQueryStringByName("user_impType");
    var systemType = {
        android: userImpType == "android" || u.indexOf('Android') > -1, //是否为android终端
        ios: userImpType == "ios" || !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/) //是否为ios终端
    };
    return systemType;
}

var app_common = {
    sendTitle: function (json) {
        sendMessageToNative(json);
    },
    appBack: function () {
        var chnl = getQueryStringByName("chnl");
        var paramMap = {
            "funcNo": "100001",	// 功能号
            "funName": "back",    // 功能名称
            "chnl": chnl 		// 渠道号
        }
        sendMessageToNative(paramMap);
    }
};

function getQueryStringByName(name) {
    var result = location.search.match(new RegExp("[\?\&]" + name + "=([^\&]+)", "i"));
    if (result == null || result.length < 1) {
        return "";
    }
    return result[1];
}
