var background_color = Common.getQueryStringByName("background_color");
var color_y = Common.getQueryStringByName("color_y");
var color_n = Common.getQueryStringByName("color_n");
var access_token;
$(function() {
    /*****************获取token*********************/
    $.ajax({
        type:'GET',
        url:window.service_prefix + '/token/getAccessToken',
        dataType:'json',
        success:function(data){
            var jsonText = JSON.parse(data.data);
            access_token = jsonText.access_token;
            ZLInit();
        },
        error: function (xhr, status, msg) {
            layer.open({
                type: 0,
                style: 'word-break: break-all;',
                content: msg
            });
        }
    });
    /***********************************************/
    if(null != background_color || "" != background_color){
        if(background_color.indexOf("%23") != -1){
            background_color = background_color.replace("%23","#");
        }
        $('<style>.bar-nav{background-color:'+ background_color +'}</style>').appendTo('head');
        $('<style>.icon-back:after, .icon-back:before{color:'+ background_color +'}</style>').appendTo('head');
    }
    if(null != color_y || "" != color_y){
        if(color_y.indexOf("%23") != -1){
            color_y = color_y.replace("%23","#");
        }
        $('<style>.btn-group .btn.active{color:'+ color_y+'}</style>').appendTo('head');
        $('<style>.btn-group .btn.active:after{background:'+ color_y+'}</style>').appendTo('head');
        $('<style>.icon-back:before{color: '+ color_y+'}</style>').appendTo('head');
    }
    if(null != color_n || "" != color_n){
        if(color_n.indexOf("%23") != -1){
            color_n = color_n.replace("%23","#");
        }
        $('<style>.btn-group .btn{color: '+ color_n+'}</style>').appendTo('head');
    }
});
/**
 * 可伸缩布局方案btn-group
 * rem计算方式：设计图尺寸px / 100 = 实际rem  例: 100px = 1rem
 */
!function (window) {
    /* 设计图文档宽度 */
    var docWidth = 375;

    var doc = window.document,
        docEl = doc.documentElement,
        resizeEvt = 'orientationchange' in window ? 'orientationchange' : 'resize';

    var recalc = (function refreshRem() {
        var clientWidth = docEl.getBoundingClientRect().width;

        /* 8.55：小于320px不再缩小，11.2：大于420px不再放大 */
        docEl.style.fontSize = Math.max(Math.min(100 * (clientWidth / docWidth), 112), 85.333) + 'px';

        return refreshRem;
    })();


    if (!doc.addEventListener) return;
    window.addEventListener(resizeEvt, recalc, false);
    doc.addEventListener('DOMContentLoaded', recalc, false);

}(window);



//主力、品种panel切换js
//panel切换
$('#btnSwitch a').on('click', function () {
    var $this = $(this);
    $('#btnSwitch a').removeClass('active');
    $this.addClass('active');
    if ($this.data('panel') == 'zl') {
        $('#panelPZ').removeClass('active');
        $('#panelZL').addClass('active');
        $('#dataBarPZ').removeClass('active');
        $('#dataBarZL').addClass('active');
        if ($this.data('init') != true) {
            ZLInit();
        }
    }
    if ($this.data('panel') == 'pz') {
        $('#panelZL').removeClass('active');
        $('#panelPZ').addClass('active');
        $('#dataBarZL').removeClass('active');
        $('#dataBarPZ').addClass('active');

        if ($this.data('init') != true) {
            PZInit();
        }
    }
});

//图表相关JS


//画图
function drawFundChart(params) {
    var defaultParams = {
        wrap: null,
        data: [],
        callback: $.noop
    };
    $.extend(defaultParams, params);
    var myChart = echarts.init(defaultParams.wrap[0]);
    var option = {
        color: ['#E64340','#1AAD19'],
        dataSum: defaultParams.data.date.length,
        tooltip: {
            trigger: 'axis',
            axisPointer: {
                type: 'cross',
                snap: true,
                label: {
                    precision: 0,
                    backgroundColor: '#6a7985'
                }
            }
        },
        legend: {
            data: [''],
            show: false
        },
        grid: {
            top: 10,
            left: 10,
            right: 30,
            bottom: 10,
            containLabel: true
        },
        xAxis: {
            type: 'category',
            boundaryGap: false,
            data: defaultParams.data.date.map(function (item) {
                return item;
            }),
            axisLabel: {
                interval: function (index, value) {
                    if (index === 0 || index === option.dataSum - 1) {
                        return true
                    }
                    if (index === Math.floor(option.dataSum / 2)) {
                        return true
                    }
                },
                showMinLabel: true,
                showMaxLabel: true,
                textStyle: {
                    color: '#888',
                    fontSize: 12,
                    algin: 'left'
                },
                margin: 10
            },
            axisLine: {
                show: false
            },
            axisTick: {
                show: false
            }
        },
        yAxis: {
            type: 'value',
            splitNumber: 3,
            axisLine: {
                show: false
            },
            axisTick: {
                show: false
            },
            axisLabel: {
                formatter: function (value, index) {
                    if (value < 1000) return value;
                    return parseInt((value / 1000)) + 'K';
                },
                textStyle: {
                    color: '#a4a4a4',
                    fontSize: 10
                }
            },
            splitLine: {
                lineStyle: {
                    color: '#EFEFEF'
                }
            }
        },
        series: [
            {
                name: '多单量',
                type: 'line',
                symbol: 'none',
                lineStyle: {
                    normal: {
                        color: '#E64340'
                    }
                },
                data: defaultParams.data.data1.map(function (item) {
                    return item;
                })
            },
            {
                name: '空单量',
                type: 'line',
                symbol: 'none',
                lineStyle: {
                    normal: {
                        color: '#1AAD19'
                    }
                },
                data: defaultParams.data.data2.map(function (item) {
                    return item;
                })
            }
        ]
    };
    myChart.setOption(option);
    defaultParams.callback();
}

function jj_date(offset, start) {
    var now = new Date();
    if(start){
        now = new Date(start);
    }
    var rs = now;
    rs.setTime(now.getTime() + offset);
    return rs;
}

/**
 * 格式化日期
 * @param date
 * @param format
 */
function getFormatDate (date, format) {
    var paddNum = function (num) {
        num += "";
        return num.replace(/^(\d)$/, "0$1");
    };

    //指定格式字符
    var cfg = {
        yyyy: date.getFullYear() //年 : 4位
        , yy: date.getFullYear().toString().substring(2)//年 : 2位
        , M: date.getMonth() + 1  //月 : 如果1位的时候不补0
        , MM: paddNum(date.getMonth() + 1) //月 : 如果1位的时候补0
        , d: date.getDate()   //日 : 如果1位的时候不补0
        , dd: paddNum(date.getDate())//日 : 如果1位的时候补0
        , hh: paddNum(date.getHours())  //时
        , mm: paddNum(date.getMinutes()) //分
        , ss: paddNum(date.getSeconds()) //秒
    };
    format || (format = "yyyy-MM-dd hh:mm:ss");
    return format.replace(/([a-z])(\1)*/ig, function (m) {
        return cfg[m];
    });
}