/**
 * 期货合约F10 综合
 */

var we_type = CommFutures.getQueryStringByName("we_type");//显示类型 1：普通期货合约 2:商品/股票期权 3：原油
var contract_code =CommFutures.getQueryStringByName("contract_code");//合约代码

var exchange_code =CommFutures.getQueryStringByName("exchange_code");//交易所代码
var contract_state =CommFutures.getQueryStringByName("contract_state");//合约状态
if(contract_state==null || contract_state==""){
    contract_state="1";//正在交易的
}
var fut_option_code =CommFutures.getQueryStringByName("fut_option_code");//合约标的
var delivery_method =CommFutures.getQueryStringByName("delivery_method");//交割方式
var fut_contract_type =CommFutures.getQueryStringByName("fut_contract_type");//合约类型

var opt_type = CommFutures.getQueryStringByName("opt_type");//期权类型
if(opt_type==null || opt_type==""){
    opt_type = 2;
}
/**
 * 主逻辑函数
 */
$(function(){
	hideAll();
	if(we_type){
		if(we_type=="1"){
			/*******普通期货F10*********/
			$("#pt_f10").show();
		    var jsonVal={
		        "contract_code":contract_code
		    };
		    getF10Info(jsonVal);
		}else if(we_type=="2"){
			$("#qq_f10").show();
		    /*******期权F10资讯*********/
		    var jsonVal={
		        "option_codes":contract_code,
		        "opt_type":opt_type
		    };
		    getQqF10Info(jsonVal);
		}else if(we_type=="3"){
			$("#yy_f10").show();
			/*******原油期货F10*********/
		    getCrudeF10Info();
		}
		
	}else{
		alert("请输入F10类型参数!");
	}
	CommFutures.sendSilentReg()

});

/**
 * 描述：期货资讯F10
 * @param jsonVal
 * @returns {boolean}
 */
function getF10Info(jsonVal){
	 initData();
    if(jsonVal.contract_code == ""||jsonVal.contract_code==null){
        alert("请输入合约代码!");
        return false;
    }
    $.ajax({
        type:'GET',
        url:CommFutures.token_url,
        dataType:'json',
        success:function(data){
            var jsonText = JSON.parse(data.data);
            jsonVal['access_token'] = jsonText.access_token;
            $.ajax({
                type:'GET',
                data:jsonVal,
                url:CommFutures.f10_url,
                dataType:'json',
                success:function(data){
                    if(data  && data.data.length > 0){
                        var result = data.data[0];
                        
                        $("#pt_exchange_Name").text(CommFutures.exchange_codeForName[jsonVal.exchange_code]);
                        $("#pt_contract_code").text(result.contract_code);
                        $("#pt_contract_abbr").text(result.contract_abbr);
                        $("#pt_contract_name").text(result.contract_name);
                        $("#pt_fut_contract_type").text(CommFutures.fut_contract_typeName[result.fut_contract_type]);
                        $("#pt_contract_multiplier").text(result.contract_multiplier);
                        //$("#trading_commission").text(result.trading_commission);
                        $("#pt_price_unit").text(result.price_unit);
                        $("#pt_littlest_changeunit").text(result.littlest_changeunit);
                        $("#pt_changepct_limit").text(result.changepct_limit);
                        $("#pt_contract_month").text(result.contract_month);
                        $("#pt_exchange_date").text(result.exchange_date);
                        $("#pt_lasttrading_date").text(result.lasttrading_date);
                        $("#pt_lasttradingdate_desc").text(result.lasttradingdate_desc);
                        $("#pt_lastdelivery_date").text(result.lastdelivery_date);
                        $("#pt_lastdeliverydate_desc").text(result.lastdeliverydate_desc);
                        $("#pt_delivery_grades").text(result.delivery_grades);
                        //$("#min_marginratio").text(result.min_marginratio);
                        $("#pt_delivery_method").text(CommFutures.delivery_methodName[result.delivery_method]);

                        getJYdata();
                    }
                },
                error:function(){}
            });


        },
        error:function(){}
    });
}

/**
 * 描述：原油F10
 * @param jsonVal
 * @returns {boolean}
 */
function getCrudeF10Info(){
	if(contract_code === "" || contract_code==null || contract_code==undefined){
    	initYyData();
        alert("请输入合约代码!");
        return false;
    }
    $.ajax({
        type:'GET',
        url:CommFutures.token_url,
        dataType:'json',
        success:function(data){
            var jsonText = JSON.parse(data.data);
            $.ajax({
                type:'GET',
                data:{
                    "contract_code":contract_code,
                    "access_token":jsonText.access_token
                },
                url:CommFutures.future_crude_url,
                dataType:'json',
                success:function(data){
                    if(data  && data.data.length > 0){
                        var result = data.data[0];
                        $("#yy_contract_name").text(result.contract_name);//合约简称
                        $("#yy_fut_contract_type").text(result.fut_contract_type);//合约类型
                        $("#yy_contract_multiplier").text(result.contract_multiplier);//交易单位
                        $("#yy_price_unit").text(result.price_unit);//报价单位
                        $("#yy_littlest_changeunit").text(result.littlest_changeunit);//最小变动价位
                        $("#yy_changepct_limit").text(result.changepct_limit);//每日涨跌幅度
                        $("#yy_contract_month").text(result.contract_month);//合约交割月份
                        $("#yy_exchange_date").text(result.exchange_date);//交易时间
                        $("#yy_lasttrading_date_desc").text(result.lasttrading_date);//最后交易日描述
                        $("#yy_lasttrading_date").text("");//最后交易日
                        $("#yy_delivery_date_desc").text(result.delivery_date);//交割日期描述
                        $("#yy_delivery_date").text("");//交割日期
                        $("#yy_delivery_grades").text(result.delivery_grades);//交割等级
                        $("#yy_delivery_method").text(CommFutures.delivery_methodName[result.delivery_method]);//交割方式
                        $("#yy_contract_code").text("");//合约代码

                        getJYdata();
                    }
                },
                error:function(){}
            });
        },
        error:function(){}
    });
}

/**
 * 描述：商品期权F10
 * @param jsonVal
 * @returns {boolean}
 */
function getQqF10Info(jsonVal){
	 initQqData();
    if(jsonVal.option_codes == ""||jsonVal.option_codes==null){
        alert("请输入合约代码!");
        return false;
    }
    $.ajax({
        type:'GET',
        url:CommFutures.token_url,
        dataType:'json',
        success:function(data){
            var jsonText = JSON.parse(data.data);
            $.ajax({
                type:'GET',
                data:{
                    "option_codes":jsonVal.option_codes,
                    "opt_type":jsonVal.opt_type,
                    "access_token":jsonText.access_token
                },
                url:CommFutures.future_f10_url,
                dataType:'json',
                success:function(data){
                    if(data  && data.data.length > 0){
                        var result = data.data[0]
                        $("#qq_secu_code").text(result.secu_attr);
                        $("#qq_price_change_ratio").text(result.price_change_ratio_desc);
                        $("#qq_options_type").text(CommFutures.contract_typeName[result.options_type]);
                        $("#qq_option_code").text(result.option_code);
                        $("#qq_warrant_way").text(CommFutures.warrantway_typeName[result.warrant_way]);
                        $("#qq_exchange_type").text(CommFutures.futureExchange_codeForName[result.exchange_type]);
                        $("#qq_exercise_price").text(result.exercise_price);
                        $("#qq_expiration_date").text(result.expiration_date);
                        $("#qq_trading_time_desc").text(result.trading_time_desc);
                        $("#qq_contract_multiplier").text(result.contract_multiplier);
                        $("#qq_price_unit").text(result.price_unit);
                        $("#qq_littlest_changeunit").text(result.littlest_changeunit);
                        $("#qq_contract_month").text(result.contract_month_desc);
                        $("#qq_lasttrading_date").text(result.lasttrading_date);

                        //getJYdata();
                    }
                },
                error:function(){}
            });


        },
        error:function(){}
    });
}

function getJYdata(){
    $.ajax({
        type:'GET',
        url:"../model/fut_contract?lableCode="+contract_code,
        dataType:'json',
        success:function(data){
            if(data  && data.data && data.data.data){
                var result = data.data.data.ratioValue;
                $("#yy_changepct_limit").html("上一交易日结算价±"+result+"%");
                //$("#qq_changepct_limit").html("上一交易日结算价±"+result+"%");
                $("#pt_changepct_limit").html("上一交易日结算价±"+result+"%");
            }
        },
        error:function(){}
    });
}

function initQqData(){
    $("#qq_secu_code").text("--");
    $("#qq_price_change_ratio").text("--");
    $("#qq_options_type").text("--");
    $("#qq_option_code").text("--");
    $("#qq_warrant_way").text("--");
    $("#qq_exchange_type").text("--");
    $("#qq_exercise_price").text("--");
    $("#qq_expiration_date").text("--");
    $("#qq_trading_time_desc").text("--");
    $("#qq_contract_multiplier").text("--");
    $("#qq_price_unit").text("--");
    $("#qq_littlest_changeunit").text("--");
    $("#qq_contract_month").text("--");
    $("#qq_lasttrading_date").text("--");
}
function initData(){
    $("#pt_exchange_Name").text("--");
    $("#pt_contract_code").text("--");
    $("#pt_contract_abbr").text("--");
    $("#pt_contract_name").text("--");
    $("#pt_fut_contract_type").text("--");
    $("#pt_contract_multiplier").text("--");
    //$("#trading_commission").text("--");
    $("#pt_price_unit").text("--");
    $("#pt_littlest_changeunit").text("--");
    $("#pt_changepct_limit").text("--");
    $("#pt_contract_month").text("--");
    $("#pt_exchange_date").text("--");
    $("#pt_lasttrading_date").text("--");
    $("#pt_lasttradingdate_desc").text("--");
    $("#pt_lastdelivery_date").text("--");
    $("#pt_lastdeliverydate_desc").text("--");
    $("#pt_delivery_grades").text("--");
    //$("#min_marginratio").text("--");
    $("#pt_delivery_method").text("--");
    $("#pt_contract_introduction").text("--");
}
function initYyData(){
    $("#yy_contract_name").text("--");//合约简称
    $("#yy_contract_code").text("--");//合约代码
    $("#yy_ontract_multiplier").text("--");//交易单位
    $("#yy_price_unit").text("--");//报价单位
    $("#yy_littlest_changeunit").text("--");//最小变动价位
    $("#yy_changepct_limit").text("--");//每日涨跌幅度
    $("#yy_contract_month").text("--");//合约交割月份
    $("#yy_exchange_date").text("--");//交易时间
    $("#yy_lasttrading_date_desc").text("--");//最后交易日
    $("#yy_lasttrading_date").text("--");//最后交易日描述
    $("#yy_delivery_date_desc").text("--");//交割日期描述
    $("#yy_delivery_date").text("--");//交割日期
    $("#yy_delivery_grades").text("--");//交割等级
    $("#yy_fut_contract_type").text("--");//合约类型
    $("#yy_delivery_method").text("--");//交割方式

}
function hideAll(){
	$("#pt_f10").hide();
	$("#qq_f10").hide();
	$("#yy_f10").hide();
}