/**
 * mPicker Plugin
 * 
 */
// !function(window){
	
	// "use strict";
	$.extend($.fn,{
		/**
     	* @desc 因为off方法目前不可以移除绑定的匿名函数，现在直接暴力移除所有listener
     	* @returns {offAll}
     	*/
	    offAll: function offAll() {
	    	
			var _this = this;
			
			this.each(function (index, $element) {
				var clone = $element.cloneNode(true);
				$element.parentNode.replaceChild(clone, $element);
				_this[index] = clone;
			});
			
			return this;
		}
	    
	});
	
	$.extend($,{
		/**
	     * render
	     * 取值：<%= variable %>
	     * 表达式：<% if {} %>
	     * 例子：
	     *  <div>
	     *    <div class="weui-mask"></div>
	     *    <div class="weui-dialog">
	     *    <% if(typeof title === 'string'){ %>
	     *           <div class="weui-dialog__hd"><strong class="weui-dialog__title"><%=title%></strong></div>
	     *    <% } %>
	     *    <div class="weui-dialog__bd"><%=content%></div>
	     *    <div class="weui-dialog__ft">
	     *    <% for(var i = 0; i < buttons.length; i++){ %>
	     *        <a href="javascript:;" class="weui-dialog__btn weui-dialog__btn_<%=buttons[i]['type']%>"><%=buttons[i]['label']%></a>
	     *    <% } %>
	     *    </div>
	     *    </div>
	     *  </div>
	     * A very simple template engine
	     * @param {String} tpl
	     * @param {Object=} data
	     * @returns {String}
	     */
	    render: function (tpl, data) {
	        const code = 'var p=[];with(this){p.push(\'' +
	            tpl
	                .replace(/[\r\t\n]/g, ' ')
	                .split('<%').join('\t')
	                .replace(/((^|%>)[^\t]*)'/g, '$1\r')
	                .replace(/\t=(.*?)%>/g, '\',$1,\'')
	                .split('\t').join('\');')
	                .split('%>').join('p.push(\'')
	                .split('\r').join('\\\'')
	            + '\');}return p.join(\'\');';
	        return new Function(code).apply(data);
	    },
	    /**
	     * getStyle 获得元素计算后的样式值
	     * (from http://stackoverflow.com/questions/2664045/how-to-get-an-html-elements-style-values-in-javascript)
	     */
	    getStyle: function (el, styleProp) {
	        var value, defaultView = (el.ownerDocument || document).defaultView;
	        // W3C standard way:
	        if (defaultView && defaultView.getComputedStyle) {
	            // sanitize property name to css notation
	            // (hypen separated words eg. font-Size)
	            styleProp = styleProp.replace(/([A-Z])/g, '-$1').toLowerCase();
	            return defaultView.getComputedStyle(el, null).getPropertyValue(styleProp);
	        } else if (el.currentStyle) { // IE
	            // sanitize property name to camelCase
	            styleProp = styleProp.replace(/\-(\w)/g, function (str, letter) {
					return letter.toUpperCase();
				});
				value = el.currentStyle[styleProp];
				// convert other units to pixels on IE
				if (/^\d+(em|pt|%|ex)?$/i.test(value)) {
					return (function (value) {
						var oldLeft = el.style.left,
						    oldRsLeft = el.runtimeStyle.left;
						el.runtimeStyle.left = el.currentStyle.left;
						el.style.left = value || 0;
						value = el.style.pixelLeft + 'px';
						el.style.left = oldLeft;
						el.runtimeStyle.left = oldRsLeft;
						return value;
					})(value);
				}
	            return value;
	        }
	    },
	
	    touchEvents : {
	        start: $.support.touch ? 'touchstart' : 'mousedown',
	        move: $.support.touch ? 'touchmove' : 'mousemove',
	        end: $.support.touch ? 'touchend' : 'mouseup'
	    }
	})
	
	var setTransition = function setTransition($target, time) {
	    return $target.css({
	        '-webkit-transition': 'all ' + time + 's',
	        'transition': 'all ' + time + 's'
	    });
	};
	
	/**
	 * set translate
	 */
	var setTranslate = function setTranslate($target, diff) {
	    return $target.css({
	        '-webkit-transform': 'translate3d(0, ' + diff + 'px, 0)',
	        'transform': 'translate3d(0, ' + diff + 'px, 0)'
	    });
	};
	
	/**
	 * @desc get index of middle item
	 * @param items
	 * @returns {number}
	 */
	var getDefaultIndex = function getDefaultIndex(items) {
	    var current = Math.floor(items.length / 2);
	    var count = 0;
	    while (!!items[current] && items[current].disabled) {
	        current = ++current % items.length;
	        count++;
	
	        if (count > items.length) {
	            throw new Error('No selectable item.');
	        }
	    }
	
	    return current;
	};
	
	var getDefaultTranslate = function getDefaultTranslate(offset, rowHeight, items) {
	    var currentIndex = getDefaultIndex(items);
	
	    return (offset - currentIndex) * rowHeight;
	};
	
	/**
	 * get max translate
	 * @param offset
	 * @param rowHeight
	 * @returns {number}
	 */
	var getMax = function getMax(offset, rowHeight) {
	    return offset * rowHeight;
	};
	
	/**
	 * get min translate
	 * @param offset
	 * @param rowHeight
	 * @param length
	 * @returns {number}
	 */
	var getMin = function getMin(offset, rowHeight, length) {
	    return -(rowHeight * (length - offset - 1));
	};
	
	
	$.fn.scroll = function (options) {
	    var _this = this;
	
	    var defaults = $.extend({
	        items: [], // 数据
	        scrollable: '.lui-picker__content', // 滚动的元素
	        offset: 3, // 列表初始化时的偏移量（列表初始化时，选项是聚焦在中间的，通过offset强制往上挪3项，以达到初始选项是为顶部的那项）
	        rowHeight: 34, // 列表每一行的高度
	        onChange: $.noop, // onChange回调
	        temp: null, // translate的缓存
	        bodyHeight: 7 * 34 // picker的高度，用于辅助点击滚动的计算
	    }, options);
	    var items = defaults.items.map(function (item) {
	        return '<div class="lui-picker__item' + (item.disabled ? ' lui-picker__item_disabled' : '') + '">' + item.label + '</div>';
	    }).join('');
	    var $this = $(this);
	
	    $this.find('.lui-picker__content').html(items);
	
	    var $scrollable = $this.find(defaults.scrollable); // 可滚动的元素
	    var start = undefined; // 保存开始按下的位置
	    var end = undefined; // 保存结束时的位置
	    var startTime = undefined; // 开始触摸的时间
	    var translate = undefined; // 缓存 translate
	    var points = []; // 记录移动点
	    var windowHeight = window.innerHeight; // 屏幕的高度
	
	    // 首次触发选中事件
	    // 如果有缓存的选项，则用缓存的选项，否则使用中间值。
	    var level = $this.index();
        var init_data = $this.parent().data('init-group')?$this.parent().data('init-group'):[];
        
	    if (defaults.temp !== null && defaults.temp < defaults.items.length) {
	        var index = defaults.temp;
	        
	        if($.inArray(level,init_data)<0&&defaults.isMulti){
        		defaults.onChange.call(this, defaults.items[index], index);
        		init_data.push(level)
        		$this.parent().data('init-group',init_data);//设置初始化标志，防止--多列型--后续重复触发onchange
	        }else{
	        	defaults.onChange.call(this, defaults.items[index], index);//级联型不影响
	        }
	        translate = (defaults.offset - index) * defaults.rowHeight;
	    } else {
	        var index = getDefaultIndex(defaults.items);
	        if($.inArray(level,init_data)<0&&defaults.isMulti){
	       	 	defaults.onChange.call(this, defaults.items[index], index);
	        	init_data.push(level)
        		$this.parent().data('init-group',init_data);//设置初始化标志，防止多列型后续重复触发onchange
	        }else{
	        	defaults.onChange.call(this, defaults.items[index], index);//级联型不影响
	        }

	        translate = getDefaultTranslate(defaults.offset, defaults.rowHeight, defaults.items);
	    }
	    setTranslate($scrollable, translate);
	
	    var stop = function stop(diff) {
	        translate += diff;
	
	        // 移动到最接近的那一行
	        translate = Math.round(translate / defaults.rowHeight) * defaults.rowHeight;
	        var max = getMax(defaults.offset, defaults.rowHeight);
	        var min = getMin(defaults.offset, defaults.rowHeight, defaults.items.length);
	        // 不要超过最大值或者最小值
	        if (translate > max) {
	            translate = max;
	        }
	        if (translate < min) {
	            translate = min;
	        }
	
	        // 如果是 disabled 的就跳过
	        var index = defaults.offset - translate / defaults.rowHeight;
	        while (!!defaults.items[index] && defaults.items[index].disabled) {
	            diff > 0 ? ++index : --index;
	        }
	        translate = (defaults.offset - index) * defaults.rowHeight;
	        setTransition($scrollable, .3);
	        setTranslate($scrollable, translate);
	
	        // 触发选择事件
	        defaults.onChange.call(_this, defaults.items[index], index);
	    };
	
	    function _start(pageY) {
	        start = pageY;
	        startTime = +new Date();
	    }
	    function _move(pageY) {
	        end = pageY;
	        var diff = end - start;
	
	        setTransition($scrollable, 0);
	        setTranslate($scrollable, translate + diff);
	        startTime = +new Date();
	        points.push({ time: startTime, y: end });
	        if (points.length > 40) {
	            points.shift();
	        }
	    }
	    function _end(pageY) {
	        if (!start) return;
	        /**
	         * 思路:
	         * 0. touchstart 记录按下的点和时间
	         * 1. touchmove 移动时记录前 40个经过的点和时间
	         * 2. touchend 松开手时, 记录该点和时间. 如果松开手时的时间, 距离上一次 move时的时间超过 100ms, 那么认为停止了, 不执行惯性滑动
	         *    如果间隔时间在 100ms 内, 查找 100ms 内最近的那个点, 和松开手时的那个点, 计算距离和时间差, 算出速度
	         *    速度乘以惯性滑动的时间, 例如 300ms, 计算出应该滑动的距离
	         */
	        var endTime = new Date().getTime();
	        var relativeY = windowHeight - defaults.bodyHeight / 2;
	        end = pageY;
	
	        // 如果上次时间距离松开手的时间超过 100ms, 则停止了, 没有惯性滑动
	        if (endTime - startTime > 100) {
	            //如果end和start相差小于10，则视为
	            if (Math.abs(end - start) > 10) {
	                stop(end - start);
	            } else {
	                stop(relativeY - end);
	            }
	        } else {
	            if (Math.abs(end - start) > 10) {
	                var endPos = points.length - 1;
	                var startPos = endPos;
	                for (var i = endPos; i > 0 && startTime - points[i].time < 100; i--) {
	                    startPos = i;
	                }
	
	                if (startPos !== endPos) {
	                    var ep = points[endPos];
	                    var sp = points[startPos];
	                    var t = ep.time - sp.time;
	                    var s = ep.y - sp.y;
	                    var v = s / t; // 出手时的速度
	                    var diff = v * 150 + (end - start); // 滑行 150ms,这里直接影响“灵敏度”
	                    stop(diff);
	                } else {
	                    stop(0);
	                }
	            } else {
	                stop(relativeY - end);
	            }
	        }
	
	        start = null;
	    }
	
	    /**
	     * 因为现在没有移除匿名函数的方法，所以先暴力移除（offAll），并且改变$scrollable。
	     */
	    $scrollable = $this.offAll().on('touchstart', function (evt) {
			//only for jQuery:e.originalEvent
	        _start(evt.originalEvent.changedTouches[0].pageY);
	    }).on('touchmove', function (evt) {
	        _move(evt.originalEvent.changedTouches[0].pageY);
	        evt.preventDefault();
	    }).on('touchend', function (evt) {
	        _end(evt.originalEvent.changedTouches[0].pageY);
	    }).find(defaults.scrollable);
	
	    // 判断是否支持touch事件 https://github.com/Modernizr/Modernizr/blob/master/feature-detects/touchevents.js
	    var isSupportTouch = 'ontouchstart' in window || window.DocumentTouch && document instanceof window.DocumentTouch;
	    if (!isSupportTouch) {
	        $this.on('mousedown', function (evt) {
	            _start(evt.pageY);
	            evt.stopPropagation();
	            evt.preventDefault();
	        }).on('mousemove', function (evt) {
	            if (!start) return;
	
	            _move(evt.pageY);
	            evt.stopPropagation();
	            evt.preventDefault();
	        }).on('mouseup mouseleave', function (evt) {
	            _end(evt.pageY);
	            evt.stopPropagation();
	            evt.preventDefault();
	        });
	    }
	};
	
	//picker
	function depthOf(object) {
	    var depth = 1;
	    if (object.children && object.children[0]) {
	        depth = depthOf(object.children[0]) + 1;
	    }
	    return depth;
	};
	function Result(item) {
	    this.label = item.label;
	    this.value = item.value;
	    this.newPrice = item.newPrice;
	    this.zhangFu = item.zhangFu;
	}
	Result.prototype.toString = function () {
	    return this.value;
	};
	Result.prototype.valueOf = function () {
	    return this.value;
	};
	
	var _sington = undefined;
	var temp = {}; // temp 存在上一次滑动的位置
	
	//datePicker
	
	/**
	 * picker 多列选择器。
	 * @param {array} bin参考example。
	 * @param {object} options 配置项
	 * @param {number=} [options.depth] picker深度(也就是picker有多少列) 取值为1-3。如果为空，则取items第一项的深度。
	 * @param {string=} [options.id=default] 作为picker的唯一标识，作用是以id缓存当时的选择。（当你想每次传入的defaultValue都是不一样时，可以使用不同的id区分）
	 * @param {string=} [options.className] 自定义类名
	 * @param {string=} [options.container] 指定容器
	 * @param {array=} [options.defaultValue] 默认选项的value数组
	 * @param {function=} [options.onChange] 在picker选中的值发生变化的时候回调
	 * @param {function=} [options.onConfirm] 在点击"确定"之后的回调。回调返回选中的结果(Array)，数组长度依赖于picker的层级。
	 *
	 * ★★★★★★★★ 隐藏技能★★★★★★★★
	 * @event options.className#change.level(n) n:1-5 对应n的level滚动完成时触发的事件，仅对多列型picker有效
	 * 
	 * @return {object} 返回对象
	 * @return {object=} [return.picker] 返回一个对象节点,为[options.className]所在的控件最外层节点;
	 * @return {function=} [return.changeLevel(level,items)] 返回一个方法,传入多列形式的items和level可改变此level下的滚动数据，仅对多列型picker有效
	 * 
	 * @example
	 * // 单列picker
	 * $.picker([
	 * {
	 *     label: '飞机票',
	 *     value: 0,
	 *     disabled: true // 不可用
	 * },
	 * {
	 *     label: '火车票',
	 *     value: 1
	 * },
	 * {
	 *     label: '汽车票',
	 *     value: 3
	 * },
	 * {
	 *     label: '公车票',
	 *     value: 4,
	 * }
	 * ], {
	 *    className: 'custom-classname',
	 *    container: 'body',
	 *    defaultValue: [3],
	 *    onChange: function (result) {
	 *        console.log(result)
	 *    },
	 *    onConfirm: function (result) {
	 *        console.log(result)
	 *    },
	 *    id: 'singleLinePicker'
	 * });
	 *
	 * @example
	 * // 多列picker
	 * $.picker([
	 *     {
	 *         label: '1',
	 *         value: '1'
	 *     }, {
	 *         label: '2',
	 *         value: '2'
	 *     }, {
	 *         label: '3',
	 *         value: '3'
	 *     }
	 * ], [
	 *     {
	 *         label: 'A',
	 *         value: 'A'
	 *     }, {
	 *         label: 'B',
	 *         value: 'B'
	 *     }, {
	 *         label: 'C',
	 *         value: 'C'
	 *     }
	 * ], {
	 *     defaultValue: ['3', 'A'],
	 *     onChange: function (result) {
	 *         console.log(result);
	 *     },
	 *     onConfirm: function (result) {
	 *         console.log(result);
	 *     },
	 *     id: 'multiPickerBtn'
	 * });
	 *
	 * @example
	 * // 级联picker
	 * $.picker([
	 * {
	 *     label: '飞机票',
	 *     value: 0,
	 *     children: [
	 *         {
	 *             label: '经济舱',
	 *             value: 1
	 *         },
	 *         {
	 *             label: '商务舱',
	 *             value: 2
	 *         }
	 *     ]
	 * },
	 * {
	 *     label: '火车票',
	 *     value: 1,
	 *     children: [
	 *         {
	 *             label: '卧铺',
	 *             value: 1,
	 *             disabled: true // 不可用
	 *         },
	 *         {
	 *             label: '坐票',
	 *             value: 2
	 *         },
	 *         {
	 *             label: '站票',
	 *             value: 3
	 *         }
	 *     ]
	 * },
	 * {
	 *     label: '汽车票',
	 *     value: 3,
	 *     children: [
	 *         {
	 *             label: '快班',
	 *             value: 1
	 *         },
	 *         {
	 *             label: '普通',
	 *             value: 2
	 *         }
	 *     ]
	 * }
	 * ], {
	 *    className: 'custom-classname',
	 *    container: 'body',
	 *    defaultValue: [1, 3],
	 *    onChange: function (result) {
	 *        console.log(result)
	 *    },
	 *    onConfirm: function (result) {
	 *        console.log(result)
	 *    },
	 *    id: 'doubleLinePicker'
	 * });
	 */
	function picker() {
		
		var pickerTpl = 
		'<div class="<%= className %>">'+
		'	 <div class="lui-mask-modal"></div>'+
		'    <div class="lui-picker">'+
		'        <div class="lui-picker__hd">'+
		'            <a href="javascript:;" data-action="cancel" class="lui-picker__action">取消</a>'+
		'            <a href="javascript:;" data-action="select" class="lui-picker__action" id="lui-picker-confirm">确定</a>'+
		'        </div>'+
		'        <div class="lui-picker__bd"></div>'+
		'    </div>'+
		'</div>';
		
		var groupTpl = 
		'<div class="lui-picker__group">'+
	    '	<div class="lui-picker__mask"></div>'+
	    '	<div class="lui-picker__indicator"></div>'+
	    '	<div class="lui-picker__content"></div>'+
		'</div>';
		
	    if (_sington) return _sington;

	    // 配置项
	    var options = arguments[arguments.length - 1];
	    var defaults = $.extend({
	        id: 'default',
	        className: '',
	        container: 'body',
	        autoMulti: false,
	        onChange: $.noop,
	        onConfirm: $.noop,
	        onLevel1: $.noop,
	        onLevel2: $.noop,
	        onLevel3: $.noop,
	        onLevel4: $.noop,
	        onLevel5: $.noop,
	    }, options);
	
	    // 数据处理
	    var items = undefined;
	    var isMulti = false; // 是否多列的类型
	    if (arguments.length > 2) {
	        var i = 0;
	        items = [];
	        while (i < arguments.length - 1) {
	            items.push(arguments[i++]);
	        }
	        isMulti = true;
	    } else {
	        items = arguments[0];
	    }
	    // 获取缓存
	    temp[defaults.id] = temp[defaults.id] || [];
	    var result = [];
	    var lineTemp = temp[defaults.id];
	    var $picker = $($.render(pickerTpl, defaults));
	    var depth = options.depth || (isMulti ? items.length : depthOf(items[0])),
	        groups = '';
	
	    // 显示与隐藏的方法
	    function show() {
	        $(defaults.container).append($picker);
	
	        // 这里获取一下计算后的样式，强制触发渲染. fix IOS10下闪现的问题
	        $.getStyle($picker[0], 'transform');
	
	        $picker.find('.lui-mask-modal').addClass('lui-animate-fade-in');
	        $picker.find('.lui-picker').addClass('lui-animate-slide-in-up');
	    }
	    function _hide(callback) {
	        _hide = $.noop; // 防止二次调用导致报错
	
	        $picker.find('.lui-mask-modal').addClass('lui-animate-fade-out');
	        $picker.find('.lui-picker').addClass('lui-animate-slide-out-down').on('animationend webkitAnimationEnd', function () {
	            $picker.remove();
	            _sington = false;
	            callback && callback();
	        });
	    }
	    function hide(callback) {
	        _hide(callback);
	    }
		
	    // 初始化滚动的方法
	    function scroll(items, level) {
	        if (lineTemp[level] === undefined && defaults.defaultValue && defaults.defaultValue[level] !== undefined) {
	            // 没有缓存选项，而且存在defaultValue
	            var defaultVal = defaults.defaultValue[level];
	            var index = 0,
	                len = items.length;
	
	            for (; index < len; ++index) {
	                if (defaultVal == items[index].value) break;
	            }
	            if (index < len) {
	                lineTemp[level] = index;
	            } else {
	                console.warn('Picker has not match defaultValue: ' + defaultVal);
	            }
	        }
	        $picker.find('.lui-picker__group').eq(level).scroll({
	            items: items,
	            temp: lineTemp[level],
	            isMulti: isMulti,
	            onChange: function onChange(item, index) {
	                //为当前的result赋值。
	                if (item) {
	                    result[level] = new Result(item);
	                } else {
	                    result[level] = null;
	                }
	                lineTemp[level] = index;
	
	                if (isMulti) {
	                    defaults.onChange(result);
	                    var $pickerNode = $($picker[0]);
	                    switch(level)
	                    {
	                    	case 0:
		                    	$pickerNode.trigger($.Event('change.level1',{
		                    		export : result
		                    	}))
		                    	break;
		                    case 1:
		                    	$pickerNode.trigger($.Event('change.level2',{
		                    		export : result
		                    	}))
		                    	break;
		                    case 2:
		                    	$pickerNode.trigger($.Event('change.level3',{
		                    		export : result
		                    	}))
		                    	break;
		                    case 3:
		                    	$pickerNode.trigger($.Event('change.level4',{
		                    		export : result
		                    	}))
		                    	break;
		                    case 4:
		                    	$pickerNode.trigger($.Event('change.level5',{
		                    		export : result
		                    	}))
		                    	break;
	                    }
	                } else {
	                    /**
	                     * @子列表处理
	                     * 1. 在没有子列表，或者值列表的数组长度为0时，隐藏掉子列表。
	                     * 2. 滑动之后发现重新有子列表时，再次显示子列表。
	                     *
	                     * @回调处理
	                     * 1. 因为滑动实际上是一层一层传递的：父列表滚动完成之后，会call子列表的onChange，从而带动子列表的滑动。
	                     * 2. 所以，使用者的传进来onChange回调应该在最后一个子列表滑动时再call
	                     */
	                    if (item.children && item.children.length > 0) {
	                    	var $group = $picker.find('.lui-picker__group').eq(level + 1);
	                    	var slideOut = $group.hasClass('lui-picker-group-hide');
	                        $group.removeClass('lui-picker-group-hide');
	                        !isMulti && function(){
	                        	scroll(item.children, level + 1);
	                        	$group = $picker.find('.lui-picker__group').eq(level + 1);
	                        	if(slideOut){
	                        		$group.addClass('lui-picker-group-hide')
	                        		setTimeout(function(){
	                        			$group.removeClass('lui-picker-group-hide')
	                        		},100);
	                        	}
	                        	//处理下，解决由于节点变化导致的动画bug
	                        }(); // 不是多列的情况下才继续处理children
	                    } else {
	                    	
	                            //如果子列表test不通过，子孙列表都隐藏。
	                            var $items = $picker.find('.lui-picker__group');
	                            $items.each(function (index,ele) {
	                                if (index > level) {
	                                    $(ele).addClass('lui-picker-group-hide');
	                                }
	                            });
	
	                            result.splice(level + 1);
	
	                            defaults.onChange(result);
	                        }
	                }
	            },
	            onConfirm: defaults.onConfirm
	        });
	    }
	
	    while (depth--) {
	        groups += groupTpl;
	    }
	
	    $picker.find('.lui-picker__bd').html(groups);
	    show();
	
	    if (isMulti) {
	        $.each(items,function (index,item) {
	            scroll(item, index);
	        });
	    } else {
	        scroll(items, 0);
	    }
		
	    $picker.on('click', '.lui-mask-modal', function () {
	        hide();
	    }).on('click', '.lui-picker__action', function () {
	        hide();
	    }).on('click', '#lui-picker-confirm', function () {
	        defaults.onConfirm(result);
	    });
	
	    _sington = $picker[0];
	    _sington.hide = hide;
	    
	   	var changeLevel = function(level,items){
	    	scroll(items,level-1);
	    }
	    
	    return {
	    	picker : _sington,
	    	changeLevel : changeLevel,
	    };
	}
	
	/**
	 * dataPicker 时间选择器，由picker拓展而来，提供年、月、日的选择。
	 * @param options 配置项
	 * @param {string=} [options.id=datePicker] 作为picker的唯一标识
	 * @param {number=|string|Date} [options.start=2000] 起始年份，如果是 `Number` 类型，表示起始年份；如果是 `String` 类型，格式为 'YYYY-MM-DD'；如果是 `Date` 类型，就传一个 Date
	 * @param {number=|string|Date} [options.end=2030] 结束年份，同上
	 * @param {string=} [options.cron=* * *] cron 表达式，三位，分别是 dayOfMonth[1-31]，month[1-12] 和 dayOfWeek[0-6]（周日-周六）
	 * @param {string=} [options.className] 自定义类名
	 * @param {array=} [options.defaultValue] 默认选项的value数组, 如 [1991, 6, 9]
	 * @param {function=} [options.onChange] 在picker选中的值发生变化的时候回调
	 * @param {function=} [options.onConfirm] 在点击"确定"之后的回调。回调返回选中的结果(Array)，数组长度依赖于picker的层级。
	 *
	 *@example
	 * // 示例1：
	 * $.datePicker({
	 *     start: 1990,
	 *     end: 2000,
	 *     defaultValue: [1991, 6, 9],
	 *     onChange: function(result){
	 *         console.log(result);
	 *     },
	 *     onConfirm: function(result){
	 *         console.log(result);
	 *     },
	 *     id: 'datePicker'
	 * });
	 *
	 * // 示例2：
	 * $.datePicker({
	 *      start: new Date(), // 从今天开始
	 *      end: 2030,
	 *      defaultValue: [2020, 6, 9],
	 *      onChange: function(result){
	 *          console.log(result);
	 *      },
	 *      onConfirm: function(result){
	 *          console.log(result);
	 *      },
	 *      id: 'datePicker'
	 *  });
	 *
	 *  // 示例3：
	 * $.datePicker({
	 *      start: new Date(), // 从今天开始
	 *      end: 2030,
	 *      onChange: function(result){
	 *          console.log(result);
	 *      },
	 *      onConfirm: function(result){
	 *          console.log(result);
	 *      },
	 *      id: 'datePicker'
	 *  });
	 */
	
	function datePicker(options) {
	    var defaults = $.extend({
	        id: 'datePicker',
	        onChange: $.noop,
	        onConfirm: $.noop,
	        start: 2000,
	        end: 2030,
	        postfix: true,
	    }, options);
			
	    // 兼容原来的 start、end 传 Number 的用法
	    if (typeof defaults.start === 'number') {
	    	// alert(defaults.start)
	        defaults.start = new Date(defaults.start + "-01-01");
	    }
	    else if (typeof defaults.start === 'string') {
	        defaults.start = new Date(defaults.start);
	    }
	    if (typeof defaults.end === 'number') {
	        defaults.end = new Date(defaults.end + "-12-31");
	    }
	    else if (typeof defaults.end === 'string') {
	        defaults.end = new Date(defaults.end);
	    }
	    
	    var pointer;
	    
	    if(defaults.defaultValue){
	    	try{
	    		pointer = new Date(defaults.defaultValue[0]+'-'+zeroize(defaults.defaultValue[1])+'-'+zeroize(defaults.defaultValue[2]));
	    	}catch(e){
	    		
	    	}
	    }else{
	    	pointer = new Date();
	    	if(pointer.getTime()<=defaults.start.getTime()){
	    		pointer = defaults.start;
	    	}
	    	if(pointer.getTime()>=defaults.end.getTime()){
	    		pointer = defaults.end;
	    	}
	    }
	    
		var year = [];
		var month = [];
		var day = [];
		
		var year_start = defaults.start.getFullYear();
		var year_end = defaults.end.getFullYear();
		
		var fix_year = defaults.postfix?'年':'';
		var fix_month = defaults.postfix?'月':'';
		var fix_day = defaults.postfix?'日':'';
		
		for(var y = year_start;y<year_end+1;y++){
			year.push({
				label: y+fix_year,
				value: y,
			});
		}
		
		month = getMonthLevel(pointer,defaults.start,defaults.end);
		day = getDayLevel(pointer,defaults.start,defaults.end);
		
		function getMonthLevel(pointer,start,end){
			var year = pointer.getFullYear();
			var year_start = start.getFullYear();
			var year_end = end.getFullYear();
			
			var month_min = 1;
			var month_max = 12;
			
			var month = [];
			
			if(year <= year_start){
				month_min = start.getMonth()+1;
			}else if(year >= year_end){
				month_max = end.getMonth()+1;
			}
			for(var m = month_min;m<month_max+1;m++){
				month.push({
					label: m+fix_month,
					value: m,
				});
			}
			return month;
		}
		
		function getDayLevel(pointer,start,end){
			
			var day = [];
			
			var pointer_date,pointer_time,start_date,start_time,end_date,end_time;
			
			var cal_date = new Date(pointer);
			cal_date.setMonth(cal_date.getMonth()+1);
			cal_date.setDate(0);
			//计算每月最大天数
			
			pointer_date = new Date(pointer);//避免污染原对象
			pointer_date.setDate(0);
			pointer_time = pointer_date.getTime();
			
			start_date = new Date(start);//避免污染原对象
			start_date.setDate(0);
			start_time = start_date.getTime();
			
			end_date = new Date(end);//避免污染原对象
			end_date.setDate(0);
			end_time = end_date.getTime();
			
			var day_min = 1;
			var day_max = cal_date.getDate();
			
			if(new Date(pointer_time).setHours(8)<=start_time){
				day_min = start.getDate();
			}else if(new Date(pointer_time).setHours(8)>=end_time){
				day_max = end.getDate();
			}
			
			
			
			for(var d = day_min;d<day_max+1;d++){
				day.push({
					label: d+fix_day,
					value: d,
				});
			}
			return day;
		}
		
		var pickerResult = picker( year, month, day, defaults);
		var $picker = $(pickerResult.picker);
		
		$picker.on('change.level1', function(e){
			var pointer = new Date(e.export[0].value+'-01-01');
			var months = getMonthLevel(pointer,defaults.start,defaults.end)
			pickerResult.changeLevel(2,months);
		})
		$picker.on('change.level2', function(e){
			var pointer = new Date(e.export[0].value+'-'+zeroize(e.export[1].value)+'-01');
			var days = getDayLevel(pointer,defaults.start,defaults.end)
			pickerResult.changeLevel(3,days);
		})
		
	    return pickerResult;
	}
	
	
	/**
	 * timePicker 时间选择器，由picker拓展而来，提供时、分、秒的选择。
	 * @param options 配置项
	 * @param {string=} [options.id=timePicker] 作为picker的唯一标识
	 * @param {number=|string|Date} [options.start='00:00:00'] 起始时间，如果是 `Number` 类型，表示起始小时；如果是 `String` 类型，格式为 'HH:MM:SS';
	 * @param {number=|string|Date} [options.end='23:59:59'] 结束时间，同上
	 * @param {string=} [options.className] 自定义类名
	 * @param {array=} [options.defaultValue] 默认选项的value数组, 如 [23,0,0],不填则默认为现在时间
	 * @param {string=} [options.format] 时间显示格式,可选的值为'hms'/'hm'/'h'
	 * @param {function=} [options.onChange] 在picker选中的值发生变化的时候回调
	 * @param {function=} [options.onConfirm] 在点击"确定"之后的回调。回调返回选中的结果(Array)，数组长度依赖于picker的层级。
	 *
	 *@example
	 * // 示例1：
	 * $.timePicker({
	 *     start: '00:00:00',
	 *     end: '23:59:59',
	 *     defaultValue: [14, 0, 0],
	 *     type: 'hms'
	 *     onChange: function(result){
	 *         console.log(result);
	 *     },
	 *     onConfirm: function(result){
	 *         console.log(result);
	 *     },
	 *     id: 'datePicker'
	 * });
	 *
	 * // 示例2：
	 * $.timePicker({
	 *     start: '00:00:00',
	 *     end: '23:00:00',
	 *      defaultValue: [14],
	 *      onChange: function(result){
	 *          console.log(result);
	 *      },
	 *      onConfirm: function(result){
	 *          console.log(result);
	 *      },
	 *      id: 'datePicker'
	 *  });
	 *
	 */
	function timePicker(options) {
		
	    var defaults = $.extend({
	        id: 'timePicker',
	        onChange: $.noop,
	        onConfirm: $.noop,
	        start: '00:00:00',
	        end: '23:59:59',
	        format: 'hm',//精度
	        postfix: true,
	    }, options);
	    
	    if(defaults.format.indexOf('s')>-1){
	    	defaults.type = 3;
	    }else if(defaults.format.indexOf('m')>-1){
	    	defaults.type = 2;
	    }else if(defaults.format.indexOf('h')>-1){
	    	defaults.type = 1;
	    }else{
	    	return '非法类型！';
	    }
	    
	    
	    var time = new Date();
	    
	    var pointer_arr = zeroize(((defaults.defaultValue)?(defaults.defaultValue):([time.getHours(),time.getMinutes(),time.getSeconds()])).slice(0,defaults.type));
	    var start_arr = zeroize((timeArrHandler(defaults.start)).slice(0,defaults.type));
	    var end_arr = zeroize((timeArrHandler(defaults.end)).slice(0,defaults.type));
	    //获取时间数组，并作type截取
	    var fix_hour = defaults.postfix?'时':'';
		var fix_min = defaults.postfix?'分':'';
		var fix_sec = defaults.postfix?'秒':'';
	    
	    if(parseInt(pointer_arr.join(''))<=parseInt(start_arr.join(''))){
	    	pointer_arr = start_arr.concat();//深拷贝，防止打蛋肚子疼
	    }
	    if(parseInt(pointer_arr.join(''))>=parseInt(end_arr.join(''))){
	    	pointer_arr = end_arr.concat();//深拷贝
	    }
	    
	    var hour,min,sec,pickerResult,$picker;
	    
	    defaults.defaultValue = pointer_arr.concat();//深拷贝
	    
	    if(defaults.type == 1){
	    	hour = getTimeLevel(pointer_arr,start_arr,end_arr,'h');
	    	pickerResult = picker( hour,defaults);
			$picker = $(pickerResult.picker);
	    }else if(defaults.type == 2){
	    	hour = getTimeLevel(pointer_arr,start_arr,end_arr,'h');
		    min = getTimeLevel(pointer_arr,start_arr,end_arr,'m');
		    pickerResult = picker( hour, min, defaults);
			$picker = $(pickerResult.picker);
			
			$picker.on('change.level1', function(e){
				pointer_arr[0] = e.export[0].value;
				var min = getTimeLevel(pointer_arr,start_arr,end_arr,'m');
				pickerResult.changeLevel(2,min);
			})
	    }else if(defaults.type == 3){
	    	hour = getTimeLevel(pointer_arr,start_arr,end_arr,'h');
		    min = getTimeLevel(pointer_arr,start_arr,end_arr,'m');
		    sec = getTimeLevel(pointer_arr,start_arr,end_arr,'s');
		    pickerResult = picker( hour, min, sec, defaults);
			$picker = $(pickerResult.picker);
			
			$picker.on('change.level1', function(e){
				pointer_arr[0] = e.export[0].value;
				pointer_arr[1] = e.export[1].value;
				var min = getTimeLevel(pointer_arr,start_arr,end_arr,'m');
				var sec = getTimeLevel(pointer_arr,start_arr,end_arr,'s');
				pickerResult.changeLevel(2,min);
				pickerResult.changeLevel(3,sec);
				//修改了原模式，每级level变动不再触发下一级的onChange
			});
			$picker.on('change.level2', function(e){
				pointer_arr[0] = e.export[0].value;
				pointer_arr[1] = e.export[1].value;
				var sec = getTimeLevel(pointer_arr,start_arr,end_arr,'s');
				pickerResult.changeLevel(3,sec);
			})
	    }else{
	    	return '非法类型！';
	    }
		
		function getTimeLevel(pointer,start,end,level){
	    	var time = [];
	    	pointer = pointer.map(function(data){  
		        return +data;  
		    });  
	    	start = start.map(function(data){  
		        return +data;  
		    });  
		    end = end.map(function(data){  
		        return +data;  
		    });  
		    
	    	if(level == 'h'){
	    		for(var i = start[0];i<end[0]+1;i++){
					time.push({
						label: i+fix_hour,
						value: i
					});
	    		}
	    		return time;
	    	}
	    	if(level == 'm'){
	    		if(pointer[0]<=start[0]){
	    			end[1] = 59;
	    		}else if(pointer[0]>=end[0]){
	    			start[1] = 0;
	    		}else{
	    			end[1] = 59;
	    			start[1] = 0;
	    		}
	    		for(var i = start[1];i<end[1]+1;i++){
					time.push({
						label: i+fix_min,
						value: i
					});
	    		}
	    		return time;
	    	}
	    	if(level == 's'){
	    		if(pointer[0]<=start[0]&&pointer[1]<=start[1]){
	    			end[2] = 59;
	    		}else if(pointer[0]>=end[0]&&pointer[1]>=end[1]){
	    			start[2] = 0;
	    		}else{
	    			end[2] = 59;
	    			start[2] = 0;
	    		}
	    		for(var i = start[2];i<end[2]+1;i++){
					time.push({
						label: i+fix_sec,
						value: i
					});
	    		}
	    		return time;
	    	}
	    }
	    
	    function timeArrHandler(time){
	    	if(typeof time == "string"){
	    		return time.split(/[:：]/);
	    	}else if(typeof time == "object"){
	    		var time_arr = [];
	    		for(var i = 0;i<time.length;i++){
	    			time_arr.push(zeroize(time[i]));
	    		}
	    	}else{
	    		return null;
	    	}
	    }
	    
	    function timeStrHandler(time){
	    	if(typeof time == "object"){
	    		var time_string = '';
	    		$.each(time,function(i,v){
	    			(i!=0)?time_string += ':':'';
	    			time_string += zeroize(v);
	    		})
	    		return time_string;
	    	}else if(typeof time == "string"){
	    		return time;
	    	}else{
	    		return null;
	    	}
	    }
		
	    return pickerResult;
    }
	
	function zeroize(num){
		if(typeof num == "object"){
			var arr = [];
			$.each(num,function(i,v){
				v = parseInt(v);
				arr.push((Array(2).join('0') + v).slice(-2));
			})
			return arr;
		}
		return (Array(2).join('0') + num).slice(-2);
	}
	
	$.extend($,{
		mPicker : picker,
		datePicker : datePicker,
		timePicker : timePicker
	})
	
// }(window);


